var VueNotificationRenderless = (function (exports, Vue) {
  'use strict';

  Vue = Vue && Vue.hasOwnProperty('default') ? Vue['default'] : Vue;

  var Events = new Vue();

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  var VueNotificationRenderless = {
    name: 'vue-notification-renderless',
    props: {
      reverse: {
        type: Boolean,
        default: false
      }
    },
    data: function data() {
      return {
        items: []
      };
    },
    methods: {
      generateId: function generateId() {
        return Math.random().toString(36).substr(2);
      },
      addItem: function addItem(event) {
        var _this = this;

        var item = _objectSpread({
          id: this.generateId(),
          duration: 5000,
          close: function close() {
            return _this.closeItem(item);
          }
        }, event);

        if (item.duration && item.duration > 0 || !item.duration) {
          item.timer = setTimeout(function () {
            return item.close(item);
          }, item.duration);
        }

        if (this.reverse) {
          this.items.unshift(item);
        } else {
          this.items.push(item);
        }
      },
      closeItem: function closeItem(item) {
        this.items.splice(this.items.indexOf(item), 1);
      }
    },
    mounted: function mounted() {
      Events.$on('notification', this.addItem);
    },
    beforeDestroy: function beforeDestroy() {
      Events.$off('notification', this.addItem);
    },
    render: function render() {
      return this.$scopedSlots.default({
        items: this.items,
        close: this.closeItem
      });
    }
  };

  "function"!=typeof Object.assign&&(Object.assign=function(n){
  var arguments$1 = arguments;
  if(null==n){ throw new TypeError("Cannot convert undefined or null to object"); }for(var r=Object(n),t=1;t<arguments.length;t++){var e=arguments$1[t];if(null!=e){ for(var o in e){ e.hasOwnProperty(o)&&(r[o]=e[o]); } }}return r});

  var index = {
    install: function install(Vue$$1) {
      var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (this.installed) {
        return;
      }

      this.installed = true;
      Vue$$1.component(args.wrapper_name || VueNotificationRenderless.name, VueNotificationRenderless);

      Vue$$1.prototype.$notification = function (data) {
        return Events.$emit('notification', data);
      };
    }
  };

  exports.default = index;

  return exports;

}({}, Vue));
